;;
;; BriefLZ  -  small fast Lempel-Ziv
;;
;; MASM assembler depacker
;;
;; Copyright (c) 2002-2005 by Joergen Ibsen / Jibz
;; All Rights Reserved
;;
;; http://www.ibsensoftware.com/
;;
;; This software is provided 'as-is', without any express
;; or implied warranty.  In no event will the authors be
;; held liable for any damages arising from the use of
;; this software.
;;
;; Permission is granted to anyone to use this software
;; for any purpose, including commercial applications,
;; and to alter it and redistribute it freely, subject to
;; the following restrictions:
;;
;; 1. The origin of this software must not be
;;    misrepresented; you must not claim that you
;;    wrote the original software. If you use this
;;    software in a product, an acknowledgment in
;;    the product documentation would be appreciated
;;    but is not required.
;;
;; 2. Altered source versions must be plainly marked
;;    as such, and must not be misrepresented as
;;    being the original software.
;;
;; 3. This notice may not be removed or altered from
;;    any source distribution.
;;

.386
.MODEL FLAT,C

OPTION CASEMAP:NONE

PUBLIC blz_depack

.CODE

; =============================================================

getbitM MACRO                 ; get next tag-bit into carry
  LOCAL stillbitsleft
    add    dx, dx
    jnz    stillbitsleft
    mov    dx, [esi]
    lea    esi, [esi + 2]
    adc    dx, dx
  stillbitsleft:
ENDM getbitM

domatchM MACRO reg            ; copy a match, ecx = len, param = pos
    push   esi
    mov    esi, edi
    sub    esi, reg
    rep    movsb
    pop    esi
ENDM domatchM

getgammaM MACRO reg           ; gamma decode value into param
  LOCAL getmore
    mov    reg, 1
  getmore:
    getbitM
    adc    reg, reg
    getbitM
    jc     getmore
ENDM getgammaM

; =============================================================

blz_depack:
    ; blz_depack(const void *source,
    ;            void *destination,
    ;            unsigned int depacked_length);

    _len$  EQU 3*4 + 4 + 8
    _dst$  EQU 3*4 + 4 + 4
    _src$  EQU 3*4 + 4

    push   ebx
    push   esi
    push   edi

    mov    esi, [esp + _src$]
    mov    edi, [esp + _dst$]
    mov    ebx, [esp + _len$]

    cld
    mov    dx, 8000h          ; initialise tag

    add    ebx, edi           ; ebx = destination + length

  literal:
    mov    al, [esi]          ; copy literal
    inc    esi                ;
    mov    [edi], al          ;
    inc    edi                ;

    cmp    edi, ebx           ; are we done?
    jae    donedepacking

  nexttag:
    getbitM                   ; literal or match?
    jnc    literal            ;

    getgammaM ecx             ; ecx = matchlen

    getgammaM eax             ; eax = (matchpos >> 8) + 2

    add    ecx, 2             ; matchlen >= 4, so add 2

    shl    eax, 8             ; eax = high part of matchpos
    mov    al, [esi]          ; add low 8 bits of matchpos
    inc    esi                ;

    add    eax, 0fffffe01h    ; adjust matchpos (highpart-=2, lowpart+=1)

    domatchM eax              ; copy match

    cmp    edi, ebx           ; are we done?
    jb     nexttag

  donedepacking:
    mov    eax, edi           ; return unpacked length in eax
    sub    eax, [esp + _dst$] ;

    pop    edi
    pop    esi
    pop    ebx

    ret

; =============================================================

END

; =============================================================
